/*
 * ボスクラス
 */

var Boss = Class.create(Sprite, {
	initialize: function(){
		Sprite.call(this, 192, 128);
		this.image = game.assets[IMG_BOSS];
		this.frame = 0;
		this.score = 10000;
		this.init();
	},
	init: function(){
		this.mode = SLEEP;
		this.moveType = 1;
		this.scaleX = this.scaleY = 1.0;
		this.speed = 3;
		this.nextShot = 0;
		this.hitCount = 0;
		this.moveTo(30, -this.height);
		this.update = this.move;
	},
	flash :function(){
		this.opacity = 0.5;
	},
	move :function(){
		if(this.mode == ACTIVE){
			if(this.moveType == 1){
				this.y += 2;
				if(this.y > 0){
					this.moveType = 2;
					this.nextShot = game.frame + game.fps * 4;
				}
			}
			else if(this.moveType == 2){
				if(!(game.frame % 5)){
					this.opacity = 1.0;
				}
				this.x += this.speed;
				if((this.x + this.width > SCREEN_WIDTH) || (this.x < 0) ) this.speed = -this.speed;
				if(game.mode == GAME){
					if(game.frame > this.nextShot){
						var bossShot = new BossShot();
						enemys.push(bossShot);
						scGame.addChild(bossShot);
						this.nextShot = game.frame + game.fps * 4;
					}
					if(game.frame % 50 == 0){
						createBossTama();
					}
				}
			}
		}
	},
	die: function(){
		this.init();
		createGameClearObject();
	},
	onenterframe: function(){
		this.update();
		if(this.hitCount >= (BOSS_HP / 4)*3){	// HPが4/3になったらデカくなる
			this.scaleX = 1.5;
			this.scaleY = 1.5;
		}
		if(this.hitCount >= BOSS_HP){
			this.die();
			game.score += this.score;
		}
	},
});
