/*
 * ボス弾クラス
 */

var BossTama = Class.create(Sprite, {
	initialize: function(angle, speed){
		Sprite.call(this, 32, 32);
		this.mode = ACTIVE;
		this.hitType = THROW;
		this.image = game.assets[IMG_BOSSTAMA];
		this.frame = 0;
		this.angle = angle;
		this.speed = speed;
		// 弾の移動方向決定
		this.vx = this.speed * Math.cos(this.angle / 180 * Math.PI);
		this.vy = this.speed * Math.sin(this.angle / 180 * Math.PI);
		this.score = 0;
		this.moveTo(boss.x + boss.width/2-this.width/2, boss.y + boss.height/2);
		this.update = this.move;
	},
	move: function(){
		this.x += this.vx;
		this.y += this.vy;

		if(this.x < 0 || this.x > SCREEN_WIDTH || this.y < 0 || this.y > SCREEN_HEIGHT){
			scGame.removeChild(this);
			this.mode = DIE;
		}
	},
	onenterframe: function(){
		this.update();
	},
});
