/*
 * プレイヤークラス
 */

var Player = Class.create(Sprite, {
	initialize: function(){
		Sprite.call(this, SPRITE_WIDTH, SPRITE_HEIGHT);
		this.mode = ACTIVE;
		this.image = game.assets[IMG_PLAYER];
		this.frame = 0;
		this.angle = 30;
		this.sx = this.x;			// プレイヤーのタッチ位置とのx方向差分
		this.sy = this.y;			// プレイヤーのタッチ位置とのy方向差分
		this.init();
		console.log("shotInterval: " + this.shotInterval);
	},
	init: function(){
		this.rotation = 0;
		this.opacity = 1.0;
		this.scaleX = this.scaleY = 1.0;
		this.item = 0;
		this.shotInterval = SHOT_INTERVAL;
		this.moveTo(SCREEN_WIDTH/2 - SPRITE_WIDTH/2, 300);
		this.nextShot = game.frame + this.shotInterval;
		this.visible = true;
		this.update = this.hit;
	},
	hit: function(){
		// プレイヤー弾発射
		if(game.frame > this.nextShot){	
			var tama = new Tama(this.x, this.y);	// 弾を生成
			beams.push(tama);					// 弾をスタックに追加
			scGame.addChild(tama);				// 弾を表示
			this.nextShot = game.frame + this.shotInterval;
		}
	},
	toGameOver: function(){
		this.opacity = 0.8;
		this.rotate(this.angle);						// ぐるぐる回る
		if(this.rotation > 360) this.rotation = 0;
		this.scaleX = this.scaleY -= 0.05;			// 徐々に消えていく
		if(this.scaleX < 0.1) this.visible = false;
	},
	gameover: function(){
		this.visible = false;
		this.y = -10000;
	},
	onenterframe: function(){
		// 更新処理実行
		this.update();
		// 当たり判定
		if(game.mode == GAME){
			for(i in enemys){
				if(enemys[i].within(this)){
					this.update = this.toGameOver;
					this.scale(2.0, 2.0);
					createGameOverObject(this.x, this.y);
				}
			}
		}
		// アイテム処理
		if(this.item >= 3){
			this.item = 0;
			this.shotInterval -= 5;
			if(this.shotInterval <= 1) this.shotInterval = 1;
			console.log("ショット間隔短縮！: " + this.shotInterval);
		}
	},
});
