/*
 * プレイヤー弾クラス
 */

var Tama = Class.create(Sprite, {
	initialize: function(x, y){
		Sprite.call(this, 16, 16);
		this.mode = ACTIVE;
		this.image = game.assets[IMG_TAMA];
		this.frame = 0;
		this.speed = 8;
		this.moveTo(x+SPRITE_WIDTH/2-16/2, y);
		this.update = this.move;
	},
	hitCheck: function(){			// 当たり判定
		// 対ボス
		if((boss.mode == ACTIVE) && (boss.moveType == 2)){
			if(boss.within(this)){
				// ビーム消去
				scGame.removeChild(this);
				this.mode = DIE;
				// ボスのヒット値カウントと当たったときの見た目
				boss.hitCount ++;
				boss.flash();
				console.log("hitCount = " + boss.hitCount);
			}
		}
		// 対ボス以外
		for(i in enemys){
			if(enemys[i].within(this)){
				if(enemys[i].hitType == HIT){
					// ビーム消去
					scGame.removeChild(this);
					this.mode = DIE;
					// 爆破エフェクト
					var bang = new Bang(enemys[i].x, enemys[i].y);
					objects.push(bang);
					scGame.addChild(bang);
					// 敵消去
					scGame.removeChild(enemys[i]);
					enemys[i].mode = DIE;
					// アイテムが出るか？
					if(rnd(1, 3) == 1){		// 3回に1回くらいアイテムが出現
						var item = new Item(this.x, this.y);
						objects.push(item);
						scGame.addChild(item);
					}
					// 得点カウント
					game.score += enemys[i].score;
				}
			}
		}
	},
	move: function(){
		this.y -= this.speed;
		if(this.y < -this.height){
			scGame.removeChild(this);
			this.mode = DIE;
		}
	},
	onenterframe: function(){
		this.update();
		this.hitCheck();
	},
});
