/*
 * メイン
 */

window.onload = function(){
	// ゲームオブジェクト生成
	game = new Game(SCREEN_WIDTH, SCREEN_HEIGHT);
	// 画像を読み込み
	game.preload(ASSETS);

	// ゲーム開始時の処理
	game.onload = function(){
		game.mode = START;
		// タイトル画面生成
		scTitle = new Scene();
		scTitle.backgroundColor = BG_TITLE_COLOR;
		// タイトル画面に雲くんを3つ生成
		for(var i=0; i<3; i++){
			var kumo = new Kumo(rnd(SCREEN_WIDTH, SCREEN_WIDTH *i), rnd(0, SCREEN_HEIGHT-64), BG_KUMO);
			scTitle.addChild(kumo);
		}
		titleText = new MutableText(45, 220, SCREEN_WIDTH, GAME_TITLE);
		titleText.scaleX = titleText.scaleY = 1.0;
		scTitle.addChild(titleText);
		// タイトル画面でタッチするとゲーム開始
		scTitle.addEventListener("touchstart", function(){
			if(game.mode == START){
				game.replaceScene(scGame);
				// 念のため全オブジェクト消去
				clearAll();
				// 初期化処理
				player.init();				// プレイヤーを初期化
				boss.init();				// ボスを初期化
				teki1Frame = TEKI1;		// 敵1の発生確率を初期化
				teki2Frame = TEKI2;		// 敵2の発生確率を初期化
				tekiNextFrame = game.frame + game.fps * TEKI_SECONDS;	// 次に敵の出現率が上がる経過秒数を初期化
				game.score = 0;
				game.mode = GAME;
			}
		});
		
		// ゲーム画面生成
		scGame = new Scene();
		scGame.backgroundColor = BG_GAME_COLOR;
		// スコア表示用ラベル生成
		scoreText = new MutableText(24, 450, game.width, "");
		scoreText.scaleX = scoreText.scaleY = 1.0;
		scGame.addChild(scoreText);
		// 主人公生成
		player = new Player();
		scGame.addChild(player);
		// ボス生成
		boss = new Boss();
		scGame.addChild(boss);
		// 最初のタッチ時にタッチした初期位置と主人公位置の差分を取得
		scGame.addEventListener("touchstart", function(e){
			player.sx = player.x - e.x;
			player.sy = player.y - e.y;
		});
		// 指を動かしたときに主人公が相対的に移動する
		scGame.addEventListener("touchmove", function(e){
			player.x = player.sx + e.x;
			player.y = player.sy + e.y;
		});
		// ゲーム実行中の全体的な処理
		scGame.addEventListener("enterframe", function(){
			// 得点表示
			scoreText.setText("SCORE: " + game.score);
			// ゲーム中の処理
			if(game.mode == GAME){
				// 時間が経過すると敵の発生確率が上がっていく
				if(game.frame > tekiNextFrame){
					teki1Frame -= 10;
					teki2Frame -= 10;
					if(teki1Frame < 2) teki1Frame = 1;
					if(teki2Frame < 2) teki2Frame = 1;
					tekiNextFrame = game.frame + game.fps * TEKI_SECONDS;
				}
				// 敵1の生成
				if(boss.mode == SLEEP && !(game.frame % teki1Frame)){
					var teki = new Teki(1);	// 敵を生成
					enemys.push(teki);		// スタックに追加
					scGame.addChild(teki);	// 表示する
				}
				// 敵2の生成
				if(boss.mode == SLEEP && !(game.frame % teki2Frame)){
					var teki = new Teki(2);	// 敵を生成
					enemys.push(teki);		// スタックに追加
					scGame.addChild(teki);	// 表示する
				}
				// 得点によりボスが出現
				if(boss.mode == SLEEP && game.score > BOSS_SCORE){
					console.log("ボス出現!");
					boss.mode = ACTIVE;
				}
			}
			else if(game.mode == GAMEOVER){
				game.mode = WAIT;
				player.update = player.toGameOver;
			}
			else if(game.mode == WAIT){
				if(game.frame > nextSceneFrame){
					player.update = player.gameover;
					clearAll();
					game.mode = START;
					game.pushScene(scTitle);
				}
			}
			else if(game.mode == CLEAR){
				titleText.text = CLEAR_TITLE;
				if(game.frame > nextSceneFrame){
					clearAll();
					game.mode = START;
					game.pushScene(scTitle);
				}
				player.opacity -= 0.05;
			}
			// 動作停止中のオブジェクトをメモリから消去
			clearObjects(DIE);
//			console.log("enemys = " + enemys.length);
//			console.log("beams = " + beams.length);
//			console.log("objects = " + objects.length);
		});
		// 起動時のシーン
		game.pushScene(scTitle);
	};
	game.start();
};

/*
 * iPhoneのアドレスバーを消す
 */
 
setTimeout("window.scrollTo(0,1)", 10);
